#include <fcntl.h>
#include <stdio.h>
#include <sys/types.h>
#include <memory.h>
#include "config.h"

struct config cf;	/* global config structure		 */

int open(),read(),printf();

void exit();

void main(argc,argv)
	int argc;
	char **argv;
{
   int f;
   char *file;

   if(argc<2) file="config.uri";
     else file=argv[1];

   (void)memset((char *)&cf,'\0',sizeof (struct config));

   f=open(file,O_RDONLY);

   if(f==-1) 
     {
        (void)printf("Could not open configuration file '%s'.\n",file);
	exit();
     }

   if(read(f,&cf,sizeof (struct config))==-1)
     {
	(void)printf("Could not read configuration file '%s'.\n",file);
	exit();
     }

   printf("\n\nUriMUD v%s Configuration Viewer.\n",VERSION);
   printf("----------------------------------\n\n");

   printf("log\t\t: %s\nlogon_ob\t: %s\nmax_mem\t\t: %u\nmax_ed\t\t: %u\nbase_port\t: %u\nnumber of ports\t: %u\nhost_name\t: %s\n",
          cf.log, cf.logon_ob,cf.max_mem, cf.max_ed, cf.base_port, cf.port_numbers,cf.host_name);

   printf("mud_name\t: %s\nmud_lib\t\t: %s\n",
	  cf.mud_name, cf.mud_lib);

   printf("temp_dir\t: %s\ninit_file\t: %s\n", cf.temp_dir,
	  cf.init_file, cf.cpp);

   printf("\nPress <ENTER> to continue.");

   (void)getchar();

   printf("\ncpp\t\t: %s\ncp\t\t: %s\ngrep\t\t: %s\nmax_local\t: %u\nmax_cost\t: %u\nmax_array_size\t: %u\n",
	  cf.cpp,cf.cp, cf.grep, cf.max_local, cf.max_cost, cf.max_array_size);

   printf("alloc_call\t: %u\nalloc_sent\t: %u\nalloc_value\t: %u\nvartable\t: %u\n",
	  cf.alloc_call, cf.alloc_sent, cf.alloc_value, cf.vartable);

   printf("ptable\t\t: %u\nvtable\t\t: %u\nltable\t\t: %u\nstable\t\t: %u\notable\t\t: %u\n", cf.ptable, cf.vtable, cf.ltable, cf.stable, cf.otable);

   printf("\n\t--- Done ---\n");
}
