#define NAME "mail/"
/* version 2.0-UA */

pointer arr_messages;       	/* the result of explode on 'messages' */
static int loaded;				/* Flag if this users mailbox is loaded */
static int curr_mess;			/* Current message number */
static string new_message, new_subject, new_dest, new_cc;

get() {return 1;}

init() {
    add_action("start_loop", "email");
}

check_mail()
{
  if(!loaded) load_player();
  if(sizeof(arr_messages)>1) write("You have mail.\n");
	 else arr_messages=0;
}

load_player() {
    loaded = 1;
    restore_object(NAME + this_player()->query_user_name());
}

headers() {
    int i, n;
    string tmp_str, tmp_str2, rest_of_mess;
    string name;

    if (!loaded)
	load_player();
    if (!arr_messages) {
	write("No mail.\n");
	return 1;
    }
    for (i=0; i<sizeof(arr_messages); i+=2) {
	name = i/2+1 + " " + arr_messages[i];
	if (strlen(name) < 8)
	    name += "\t";
	write(name + "\t");
        n = sscanf(arr_messages[i+1],"%sRe:   %s\n%s",
		   tmp_str,tmp_str2,rest_of_mess);
        if (n == 3) write(" Re:   " + tmp_str2);
        n = sscanf(arr_messages[i+1],"%sSubj: %s\n%s",
		   tmp_str,tmp_str2,rest_of_mess);
        if (n == 3) write(" Subj: " + tmp_str2);
        n = sscanf(arr_messages[i+1],"%sDate: %s\n%s",
		   tmp_str,tmp_str2, rest_of_mess);
        if (n == 3) write(" Date: " + tmp_str2);
	write("\n");
    }
    return 1;
}

start_loop()
{
    this_player()->set_status(" is in mail.");
    loop();
    return 1;
}

loop() {
    string tmp;
	int msgs;

    if (!loaded)
	load_player();
	if(pointerp(arr_messages)) msgs=sizeof(arr_messages)/2;
    if (curr_mess < 0) curr_mess=0;
	if(msgs && curr_mess==0) curr_mess=1;
    if (curr_mess >  msgs) curr_mess=msgs;
    tmp = "(current: " + curr_mess + ") [(1 - "+ msgs + ") + - d f h l m n p pg r ";
	if(this_player()->query_sysop()) tmp+="s ";
	tmp+="q . ?]";
	write(tmp);
    input(this_player(),"get_cmd");
    return 1;
}

get_cmd(str) {
    int tmp_msg;
    string tmp;

    /*
     * First, test all nondestructive commands. The destructive commands
     * will be tested after check if new mail has arrived.
     */
    if (!loaded) 
	  {
		load_player();
		write("New mail has arrived. Command ignored\n");
		loop();
		return;
      }
	
    if (str == "q") { this_player()->set_status(-1);return 1;}
    else if (str == "r") {reply_to_message();return;}
    else if (sscanf(str, "r %d", tmp_msg)==1) { curr_mess=tmp_msg; reply_to_message(); return; }
    else if (str == "h") headers();
    else if (str == "n") { curr_mess++; print_message(); }
    else if (str == ".") print_message();
    else if (str == "l") list_all();
    else if(str == "s" && this_player()->query_sysop()) save_message();
    else if (sscanf(str, "f %s", tmp) == 1) {forward_message(tmp);return;}
    else if (sscanf(str, "m %s", tmp) == 1) { mail_to(tmp); return;}
    else if (str == "?") help_msg();
    else if (str == "p" || str == "-") { curr_mess--; print_message(); }
    else if (str == "d") delete();
    else if (sscanf(str, "d %d", tmp_msg) == 1) {curr_mess=tmp_msg; delete();}
    else if (str == "pg") delete_all();
	else if(sscanf(str,"%d",tmp_msg)==1) { curr_mess=tmp_msg;print_message();}
    loop();
}

list_all() {
	int tmp;
	tmp = curr_mess;
    if(!pointerp(arr_messages)) return;
	for(curr_mess = 1;curr_mess <= sizeof(arr_messages)/2;curr_mess++)
		print_message();
	curr_mess = tmp;
}
print_message() {
    if (!pointerp(arr_messages) || curr_mess<1 || curr_mess > sizeof(arr_messages)/2) {
	write("Illegal message number " + curr_mess + "\n");
	return;
    }
    write("Message " + curr_mess + ":\n");
    write("From: " + arr_messages[curr_mess*2-2] + "\n");
    write(arr_messages[curr_mess*2-1] + "\n");
}

save_message() {
    string name;

    if (curr_mess<1 || curr_mess > sizeof(arr_messages)/2) {
	write("Illegal message number " + curr_mess + "\n");
	return;
    }
    name = "/mail/"+this_player()->query_user_name() + ".mbox";
    write_file(name, "From: " + arr_messages[curr_mess*2-2] + "\n");
    write_file(name, arr_messages[curr_mess*2-1] + "\n");
}

delete_all() {
int count;

    if(!pointerp(arr_messages)) return;
	for(count=1,curr_mess = sizeof(arr_messages)/2;curr_mess > 0;count++,curr_mess--)
	  {
		write("Removing #"+count+".\n");
		delete(1);
	   }
} 
delete(silent) {
    if (curr_mess<1 || curr_mess > sizeof(arr_messages)/2) {
	write("Illegal message number " + curr_mess + "\n");
	return;
    }
	if(!silent) write("Removing #"+curr_mess+".\n");
	arr_messages=del_element(arr_messages,curr_mess*2-1);
	arr_messages=del_element(arr_messages,curr_mess*2-2);
    save_object(NAME + this_player()->query_user_name());
}

mail_to(str) {
	new_subject=0;
	new_cc="";
    if (!str || str == "")
	  {
	    loop();
	    return 1;
      }
    mail_to_continue(str);
    return 1;
}

mail_to_continue(str) {
	object chk_user;

    str = lower_case(str);
	chk_user=clone_object("bbs/mail");
    if (file_size("/users/"+str+".o")<1) {
	write("No such user.\n");
	loop();
	return 1;
    }
    new_dest = str;
    new_message = "";
    if (new_subject)
	write("Return to get '" + new_subject + "'\n");
    write("Subject: ");
    input(this_player(),"get_subject");
    return 1;
}

get_subject(str) {
    if (str && str != "")
	new_subject = "Subj: " + str + "\n";
    if (new_subject == 0) {
	write("No subject.\n");
	loop();
	return;
    }
    write("Give message.  Finish message with '/s', or '/a' to abort.\n");
    write("]");
    input(this_player(),"more_mail");
    return;
}

more_mail(str) {
    if (str == "/a")
	  {
		write("Aborted.\n");
		loop();
		return;
      }
    if (str == "/s" || str == "**") 
	  {
		if(str=="**") write("** Is not the proper save command.\nPlease remember to use '/s' next time.\n");
		write("Cc:");
		input(this_player(),"get_cc");
		return;
      }
    new_message += str + "\n";
    write("]");
    input(this_player(),"more_mail");
}

get_cc(cc) 
{
	pointer cc_arr;
	int cnt;

	send_mail(new_dest,new_subject+"\n",new_message,cc);
	if(cc!="")
	 {
	  if(strchr(cc,';')) cc_arr = explode(cc, ';');
    	  else cc_arr = ({cc});
  	  for(cnt=0;cnt<sizeof(cc_arr);cnt++) 
	    {
	      if (cc_arr[cnt] != "") cc_arr[cnt] = lower_case(cc_arr[cnt]);
      	  if(file_size("/users/"+cc_arr[cnt]+".o")<1 && cc_arr[cnt] &&
		     cc_arr[cnt]!= "")
		  	  write("No such user, "+cc_arr[cnt]+" - Skipped.\n");
          else  send_mail(cc_arr[cnt],new_subject+"\n",new_message,
			    (sizeof(cc_arr)>1?(new_dest+";"+
				 implode(del_element(cc_arr,cnt),';')):new_dest));
	    }
     }
   loop();
}

/*
 * Send a complete mail. If the receiver is reading mail, be sure to
 * tell his mail reader that new mail has arrived.
 */
send_mail(dest, subj, mess, cc) {
	pointer send_arr;

	if(!dest || dest == "") return;
    if (cc != "")
	cc = "Cc: " + cc + "\n";
    notify_new_mail(dest, subj, capitalize(this_player()->query_user_name()));
    arr_messages=0;
    restore_object(NAME + dest);
    send_arr=({capitalize(this_player()->query_user_name()),subj+cc+
	         "Date: " + ctime(time()) + "\n\n" + mess});
    if (!arr_messages) arr_messages=send_arr; 
	  else arr_messages+=send_arr;
    save_object(NAME + dest);
    arr_messages=0;
    load_player();
}

notify_new_mail(dest, subj, name) 
{
  object ob_arr,ob;
  int i;

  ob_arr=users(1);
  if(ob_arr) 
    for(i=0;i<sizeof(ob_arr);i++)
    if (ob_arr[i]->query_user_name()==dest) 
	  {
	    tell_object(used_object(ob_arr[i]),"You have new mail from " + name + ", " + subj + "\n");
	    ob = first_inventory(ob_arr[i]);
	    if (ob) ob->invalidate();
      }
  write("Sending mail to " + capitalize(dest) + ".\n");
}

invalidate() {loaded = 0;}
drop() {return 1;}
reply_to_message() {
    int n;
    string tmp_str, tmp_str2, rest_of_mess;
    string name;

	if(curr_mess<1)  {loop();return;}
    name = lower_case(arr_messages[curr_mess*2-2]);
    n = sscanf(arr_messages[curr_mess*2-1],"%sRe:   %s\n%s",
	       tmp_str,tmp_str2,rest_of_mess);
    new_subject = " Re:   " + tmp_str2;
    n = sscanf(arr_messages[curr_mess*2-1],"%sSubj: %s\n%s",
	       tmp_str,tmp_str2,rest_of_mess);
    new_subject = " Re:   " + tmp_str2;
    new_cc = "";
    mail_to_continue(name);
}
forward_message(str) {
    int n;
    string tmp_str, tmp_str2, rest_of_mess;
    string name;

    if(curr_mess<1) {loop();return 1;}
    if (str == "") {
		write("No destination.\n");
	    loop();
		return 1;
    }
    new_cc = "";
    str = lower_case(str);
    if (file_size("/users/"+str+".o")<1) {
		write("No such player.\n");
	   	loop();
		return 1;
    }
    new_dest = str;
    new_message = arr_messages[curr_mess*2-1];
    n = sscanf(arr_messages[curr_mess*2-1],"%sRe:   %s\n%s",
	       tmp_str,tmp_str2,rest_of_mess);
    new_subject = " Re:   " + tmp_str2;
    n = sscanf(arr_messages[curr_mess*2-1],"%sSubj: %s\n%s",
	       tmp_str,tmp_str2,rest_of_mess);
    new_subject = " Re:   " + tmp_str2;
	write("Cc: ");
	input(this_player(),"get_cc");
}

help_msg() {
    write("q	Quit email.\n");
    write("d	Delete current message.\n");
    write("d <num>	Delete message number 'num'.\n");
    write("?	This help message.\n");
    write("r	Reply to current message.\n");
    write("r <num>	Reply to message number 'num'.\n");
    write("f <name> Forward the current mail to someone.\n");
    write("m <name> Mail a message to user 'name'.\n");
    write("h	Print all headers.\n");
    write("p	Print previous message.\n");
    write("n	Print next message.\n");
	write(".    Print current message.\n");
    if(this_player()->query_sysop())
    	write("s	Append current message to /mail/name.mbox\n");
    write("l    List all messages/headers.\n");
    write("pg   Purge all messages.\n");
	write("\n");
	write("  If you put a name in the Cc: a copy of the letter will be sent to\n");
	write("that person.  To not send a cc (carbon copy) just hit return.\n");
	write("To send multiple Ccs, seperate by ;s, like \"arkon;man-ing\"\n");
	write("\n");
	return 1;
}
