/*
 * This is a mudlib file. Copy it to /obj/simul_efun.c, or
 * wherever the get_simul_efun() in master.c says.
 * The functions defined in this file should only be replacements of efuns
 * no longer supported. Don't use these functions any longer, use the
 * replacement instead.
 */

// Not suported in Urimud
#if 0
/*
 * The ls() function is no longer needed, as get_dir() can do the same
 * work.
 */
/* 
 * The if part of this is lars' ls function.  A -DR compatible LPC version
 * of ls is in the else part of the if statment.  This version is (close)
 * to the output of the old list_files efun.
 */
#ifndef COMPAT_FLAG
#pragma strict_types
#pragma save_types

void ls(string path) {
    int max, i, len, tmp;
    int trunc_flag;
    string *dir;
#ifndef COMPAT_FLAG
    seteuid(geteuid(previous_object()));
#endif
    dir = get_dir (path);
#if defined(COMPAT_FLAG) && 0
    if (path[0] == '/')
	path = extract(path, 1);
    if (path != "")
	path += "/";
#else
    if (path != "/")
	path += "/";
#endif
    if (!dir) {
        write("No such directory.\n");
        return;
    }
    if (sizeof(dir) > 999)
    {
        dir = dir[0..998];
        trunc_flag = 1;
    }
    max = ("/r6/obj/master"->test_dir(dir,path));
    if (max > 79)
        max = 79;
    for (i=0; i < sizeof(dir); i++) {
	string name;
            name = dir[i];
	tmp = strlen(name);
	if (len + tmp > 79) {
	    len = 0;
	    write("\n");
	}
	write(name);
        if (len + max > 79) {
            write("\n");
            len = 0;
        } else {
            write(extract(
"                                                                                ",
                80-max+tmp));
            len += max;
        }
    }
    write("\n");
    if (trunc_flag) write("***TRUNCATED***\n");
}
#else
#if 0

#define WIDTH 79

void ls(string arg)
{
   string *f;
   int fsize;

   if (arg == "/") arg += ".";
   f = files(arg);
   fsize = sizeof(f);
   if (f && fsize)
   {
      int max, i, j, padlength, size, columns, num_per_column;
      string *out;
 
      max = 0;
      for (i=0; i<fsize; ++i)
         if ((j = strlen(f[i])) > max)
            max = j;
      max += 4; /* to compensate for the size... */
      i = WIDTH/max;
      j = i*max;
      if (j != WIDTH)
         padlength = max + (WIDTH-j)/max;
      else 
         padlength = max;
      size = 0;
      columns = WIDTH/padlength;
      num_per_column = fsize/columns + (((fsize/columns)*columns) != fsize);
      out = allocate(num_per_column);
      for (i = 0; i<columns; ++i)
         for (j=0; j<num_per_column; ++j)
            if ((i*num_per_column+j) < fsize) 
            {
               int s;

               s = file_size(arg+"/"+f[i*num_per_column+j]);
               s = s/1024 + (((s/1024)*1024) != s);
               if (out[j])
                  out[j] += pad(pad(s, -3)+
                                " "+ f[i*num_per_column+j], padlength);
               else
                  out[j] = pad(pad(s, -3)+
                                " "+ f[i*num_per_column+j], padlength);
               size += s;
            }
      write("Total "+size+"\n");
      for (i=0; i<sizeof(out); ++i)
         write(out[i]+"\n");
   }
   else write(arg+" not found.\n");
}
#endif
#endif


#endif
/*
 * filter_objects() has been renamed to filter_array().
 */
mixed *filter_objects(mixed *list, string str, object ob, mixed extra) {
    return filter_array(list, str, ob, extra);
}
filter_array(list,str,ob,extra)
{
  return call_other(ob,list,str,extra);
}

/*
 * Define functions to return the proper third person pronoun based on
 * gender.
 */
subjective(ob) {
    string gender;
    if (!ob) 
    {
       ob = this_player();
       if (!ob) return "it";
    }
    gender = ob->query_gender();
    if (gender == "male") return "he";
    else if (gender == "female") return "she";
    else return "it";
}

objective(ob) {
    string gender;
    if (!ob)
    {
       ob = this_player();
       if (!ob) return "it";
    }
    gender = ob->query_gender();
    if (gender == "male") return "him";
    else if (gender == "female") return "her";
    else return "it";
}

possessive(ob) {
    string gender;
    if (!ob) 
    {
       ob = this_player();
       if (!ob) return "its";
    }
    gender = ob->query_gender();
    if (gender == "male") return "his";
    else if (gender == "female") return "her";
    else return "its";
}
/*  Checked_Shout written by Xystron so us Wiz's can have some peace and quiet! */
/* New checked_shout for logging early 7/11/93 Wildcat */
void checked_shout(string str,int flag) {
   object *people;
   int i, level;
   people = users();
    if(this_player())
        log_file("SHOUTS",ctime(time())+" "+this_player()->query_name()+" "+str);
    else
        log_file("SHOUTS",ctime(time())+" "+file_name(previous_object())+" "+str);
   for (i=0;i<sizeof(people);i++) {
if(!people[i]) continue;
if(people[i] && environment(people[i]))
      level = people[i]->query_level();
if(level < 20 && environment(people[i])) {
    if(flag) {
	if(this_player()!=people[i])
	    tell_object(people[i],str);
    }
    else
        tell_object(people[i], str);
      } else {
if(people[i] && people[i]->listen_shout(0) < 10 && environment(people[i]))
    if(flag) {
        if(this_player()!=people[i])
            tell_object(people[i],str);
    }
    else
        tell_object(people[i],str);
      }
   }
}

/* return an array[n] of the index of the nth largest key */
sort_index(key,size) {
  int i1,i2,i_child;
  int t,k1,k_child1,k_child2;
  int index;
 
  if (!size) size = sizeof(key);
  index = allocate(size);
  for (i1=0; i1<size; i1++) /* start with unsorted indices */
    index[i1] = i1;
 
/* make a heap with element 0 being the largest element */
  for (i1=size-1; i1>=0; i1--) {
/* rectify i1's branch of the heap */
    i2 = i1;
    k1 = key[index[i2]];
    while (i2*2+1 <= size-1) {
      i_child = i2*2+1;
      k_child1 = key[index[i_child]]; /* key of child1 of i2 */
      if (i_child < size-1)               /* key of child2 of i2 */
        k_child2 = key[index[i_child+1]];
      else                            /* or null value if no child */
        k_child2 = k1;
      if (k1 >= k_child1 && k1 >= k_child2)
        break;                       /* heap rectified */
      if (k_child2 > k_child1)
        i_child++;                   /* 2nd child is best */
/* swap i2, i_child elements, continue until heap is rectified */
      t = index[i_child];
      index[i_child] = index[i2];
      index[i2] = t;
      i2 = i_child;
    }
  }
/* deheap elements, putting them at end of index array */
  for (i1=size-1; i1>=0; i1--) {
/* swap top of heap with last element in heap */
    t = index[i1];
    index[i1] = index[0];
    index[0] = t;
/* decrement heap size, rectify heap */
    i2 = 0;
    k1 = key[index[i2]];
    while (i2*2+1 <= i1-1) {
      i_child = i2*2+1;
      k_child1 = key[index[i_child]]; /* key of child1 of i2 */
      if (i_child < i1-1)               /* key of child2 of i2 */
        k_child2 = key[index[i_child+1]];
      else                            /* or null value if no child */
        k_child2 = k1;
      if (k1 >= k_child1 && k1 >= k_child2)
        break;                       /* heap rectified */
      if (k_child2 > k_child1)
        i_child++;                   /* 2nd child is best */
/* swap i2, i_child elements, continue until heap is rectified */
      t = index[i_child];
      index[i_child] = index[i2];
      index[i2] = t;
      i2 = i_child;
    }
  }
  return index;
}

// Added for Urimud

find_call_out(str) { return query_call_out(str); }
caller() { return previous_object(); }
interactive(ob) { return query_ip_number(ob); }
searcha(arr,arg) { return search_array(arr,arg); }

print(str,width) {
    if(!str)
        return "";
    if((width < 5) || (width > 70))
        width=70;
    write(sprintf("%-=*s\n",width,str));
}

format(str,width) {
    if(!str)
        return "";
    if((width <5) || (width > 70))
        width=70;
    return(sprintf("%-=*s\n",width,str));
}
intp(i) { return numberp(i)==2; }
input_to(fun,flag) { input(this_player(),fun,flag); }
exec(ob,ob2) { return new_player(ob,ob2); }
