#include "log.h"

private;
no_ext_save;

#define CHUNK 22

int talk;            	/* For talk echo */

int chunk,no_room_names,brief;

string saved_where;     	/* room location */
string current_path;		/* Current directory */
string user_name;			/* the name of the user that owns this account. */

static string cap_name;
static string more_file;	/* Used by the more command */

static int more_line,new_player;

static int log_flag,no_save,dest_on_save;

static object me;

/* link() is called when the players logges on. */

static link(arg) 
{
	no_save = 1;
	me = this_object();
	if(strncmp(file_name(previous_object()),"closed/logon",12)) 
	  {
		destruct(me);
		return;
	  }
	enable_commands(1);
	if(!restore_object("adm/"+arg+"/"+arg)) 
	 {
		write("New Sysop.\n");
		user_name=arg;
		talk=1;
		new_player = 1;
	 }
	set_living_name(user_name);
	cap_name=capitalize(user_name);
	if(new_player) set_up_new_player();
#ifdef LOG_ENTER
	log_file("SYS_ENTER", cap_name+", "+ctime(time())+".\n");
#endif
	add_standard_commands();
	add_wiz_commands();
	if(!stringp(saved_where)) saved_where="adm/"+user_name+"/workroom";
	move_object(me, saved_where);
	log_flag = 1;
	more("/news/SYS_NEWS");
}

static set_up_new_player()
{
#ifdef LOG_NEWPLAYER
	log_file("NEW_SYS", cap_name+" on:"+ctime(time())+".\n");
#endif
	if(file_size("/adm/"+user_name)==-1) 
		mkdir("/adm/"+user_name);
	if(file_size("/adm/"+user_name+"/save_inv.s")==-1)
		mkdir("/adm/"+user_name+"/save_inv.s");
	if(file_size("/adm/"+user_name+"/workroom.c")==-1)
		cp("/adm/def_room.c","/adm/"+user_name+"/workroom.c");
	new_player = 0;
}

static finnish2()
{
    if(no_room_names) write("YOU DO NOT SEE ROOM NAMES!\n\n");
    if(!current_path) current_path = "adm/" + user_name;
	verb_matching(find_link(this_object())->query_verb_pref());
	call_out("dead_check",60);
	restore_inv();
    no_save=0;
    save_me(2);
    say(cap_name+" enters the system.\n");
    if(!brief) look();
      else glance();
}

dead_check()
{
  if(!query_ip_number(this_object()))
	destruct(this_object());
  call_out("dead_check",60);
}

/* Called by command 'save' */

save_character() 
{
    save_me(1);
    write("Ok.\n");
    return 1;
}
 
reset(arg) 
{
    if (creator(this_object())) 
	  {
		illegal_patch("Cloned closed/sysop");
		no_save=1;
		destruct(this_object());
		return 1;
      }  
    chunk = CHUNK;
    user_name = "logon";
    cap_name = "Logon";
    return 1;
}

short() 
{
    string to_return;

   	to_return = cap_name;
    if(query_ip_number(this_object()) && query_idle(this_object())/60)
    	to_return += " {"+(query_idle(this_object())/60)+"}";
    if(query_ed(this_object())) to_return = "[ "+to_return+" ]";
    return to_return;
}

long() 
{
    write(short() + ".\n");
}

id(str) { return str==user_name; }
  
static add_wiz_commands() 
{
	add_action("shut_down","shutdown",2);
    add_action("teleport","goto");
    add_action("clone","clone",2);
    add_action("makedir","mkdir",2);
    add_action("removedir","rmdir",2);
    add_action("pwd","pwd",2);
    add_action("more","more",2);
    add_action("chunk_set", "chunk", 2);
    add_action("home","home",2);
    add_action("remove_file","rm",2);
    add_action("mv_file","mv",2);
    add_action("cp_file","cp",2);
    add_action("cat_file","cat",2);
    add_action("tail_file","tail",2);
    add_action("edit","ed",2);
    add_action("destruct_local_object","dest",2);
    add_action("local_commands","localcmd",2);
    add_action("wiz_score_list","wizlist");
	add_action("show_realm_list","realmlist");
    add_action("wiz_tell","stell",2);
    add_action("update_object","update",2);
    add_action("reset_object","reset",2);
    add_action("load","load",2);
    add_action("cd","cd",2);
    add_action("list_files","ls",2);
    add_action("list_files","lf",2);
    add_action("read_log","log",2);
    add_action("purge_log","purge",2);
    add_action("set_room_names","path",2);
	add_action("grep_file","grep",2);
    add_action("in_room","in",2);
    add_action("trans","trans",2);
    add_action("snoop_on","snoop",2);
}

static teleport(dest) 
{
    object ob;

    if (!dest) 
	  {
		write("Goto where ?\n");
		return 1;
      }
    ob = find_living(dest);
    if (ob)
     {
	ob = environment(ob);
	move_player("X#"+file_name(ob));
      }
    else
      {
		if(dest[0]!='/') dest=rectify_path(dest);
		if(!dest) return 1;
        if(file_size(dest+".c")<1)
            write("Invalid living name or file name.\n");
          else move_player("X#" + ++dest);
      }
   return 1;
}
 
quit()
{
#ifdef LOG_QUIT
    log_file("SYS_OUT", cap_name+", "+ctime(time())+".\n");
#endif
    dest_on_save=1;
    write("Saving "+cap_name+".\n");
    destruct(this_object());
    return 1;
}

communicate(str) 
{
    string verb;

    verb = query_verb();
    if (!str) str = "";
    say(cap_name + " says: " + str + "\n");
    if(talk) write(cap_name+" says: "+str+"\n");
      else write("Ok.\n");
    return 1;
}

put(str)
{
    int i;
    string item;
    string container;
    object item_o;
    object container_o;

    if (!str) return 0;
    if (sscanf(str, "%s in %s", item, container) != 2) 
	  {
		write("put what ?\n");
		return 1;
      }
    container = lower_case(container);
    container_o = present(container, this_player());
    if (!container_o)
	  container_o = present(container, environment(this_player()));
    if (!container_o) 
	  {
		write("There are no " + container + "s here!\n");
		return 1;
      }
    if (!container_o->can_put_and_get()) 
	  {
		write("You can't do that.\n");
		return 1;
      }
    item = lower_case(item);
    item_o = present(item, this_player());
    if (!item_o) 
	  {
		write("You have no " + item + "!\n");
		return 1;
      }
    if (item_o == container_o) return 0;
    if (item_o->prevent_insert()) return 1;
    if (item_o->drop()) return 1;
	move_object(item_o, container_o);
	say(cap_name + " puts the " + item + " in the " + container + ".\n");
	write("Ok.\n");
	return 1;
}

pick_up(str) 
{
    string item;
    string container;
    object item_o;
    object container_o;
    int weight;

    if (!str) 
 	  {
		write("What ?\n");
		return 1;
      }
    if (str == "all") 
	  {
		get_all(environment());
		return 1;
      }
	if(sscanf(str,"all %s",item)==1 && sscanf(item,"%s from %s",item_o,container)!=2 && sscanf(item,"from %s",container)!=1)
	  {
		get_all(environment(),0,lower_case(item));
		return 1;
	  }
    if (sscanf(str, "%s from %s", item, container) != 2) 
	  {
		pick_item(str);
		return 1;
      }
    container_o = present(lower_case(container));
    if (!container_o) 
	  {
		write("There is no " + container + " here.\n");
		return 1;
      }
    if (!container_o->can_put_and_get()) 
	  {
		write("You can't do that!\n");
		return 1;
      }
    if(item=="all")
     {
       get_all(container_o,lower_case(container));
       return 1;
      }
	if(sscanf(item,"all %s",item_o)==1)
	 {
	  get_all(container_o,lower_case(container),lower_case(item_o));
	  return 1;
	 }
    item_o = present(item, container_o);
    if (!item_o)
	  {
		write("There is no " + item + " in the " + container + ".\n");
		return 1;
      }
    if (!item_o->get(item)) 
	  {
		write("You can not take the " + item + " from " + container + ".\n");
		return 1;
      }
    move_object(item_o, me);
    write("Ok.\n");
    say(cap_name + " takes the " + item + " from " + container + ".\n");
    return 1;
}

pick_item(obj) 
{
    object ob;
    int i;

    obj = lower_case(obj);
    if (environment(this_player())->id(obj))
	  {
		write("You can't take that.\n");
		return 1;
      }
    ob = present(obj, environment(this_player()));
    if (!ob)
	  {
		write("That is not here.\n");
		return 1;
      }
    if (environment(ob) == me) 
	  {
		write("You already have it!\n");
		return 1;
      }
    if (!ob->get()) 
	  {
		write("You can not take that!\n");
		return 1;
      }
	move_object(ob, me);
	say(cap_name + " takes the " + obj + ".\n");
	write("Ok.\n");
	return 1;
}

drop_thing(obj) 
{
    string tmp;
    string tmp2;
    int i;

    if (!obj) 
	  {
		write("What ?\n");
		return 1;
      }
    if (obj == "all") 
	  {
		drop_all(1);
		return 1;
      }
	if(sscanf(obj,"all %s",tmp)==1)
	 {
		 drop_all(1,tmp);
		 return 1;
	 }
    if (sscanf(obj, "%s in %s", tmp, tmp2) == 2) 
	  {
		put(obj);
		return 1;
      }
    tmp = obj;
    obj = present(lower_case(obj), this_player());
    if (!obj)
	  {
		write("That is not here.\n");
		return 1;
      }
    if (drop_one_item(obj)) 
	  {
		write("Ok.\n");
		say(cap_name + " drops the " + tmp + ".\n");
      }
    return 1;
}

/*
 * Temporary move the player to another destination and execute
 * a command.
 */

static in_room(str)
{
    object room;
    object old_room;
    string cmd;
    if (!str) return 0;
    if (sscanf(str, "%s %s", room, cmd) != 2) 
	  {
		write("Usage: in ROOM CMD\n");
		return 1; 
	  }
    if (!room) 
	  {
		write("Invalid file name.\n");
		return 1; 
	  }
    old_room = environment();
    move_object(me, room);
    command(cmd);
    if(old_room) move_object(me, old_room);
	  else write("Error: return room is missing.\n");
    return 1;
}

inventory() 
{
    string inv;
    int i;

    inv = all_inventory(me);
    for(i=0;i<sizeof(inv);i++) 
	  {
		string str;

        if(!inv[i]) continue;
		str = inv[i]->short();
	 	if (str) write(capitalize(str) + ".\n");
      }
    return 1;
}
 
examine(str) { return look("at " + str); }

glance(str) { return look(str,1); }
 
look(str,mode) 
{
    object ob, ob_tmp;
    string item,inv;
    int i;
 
    if (!str)
      {
		if(!mode) environment()->long();
         else write(environment()->short()+"\n");
		inv = all_inventory(environment());
    	if(inv)
	  	  for(i=0;i<sizeof(inv);i++) 
			{
	    	  	if(!inv[i]) continue;
	    		if (inv[i] != me) 
				  {
					string short_str;
					short_str = inv[i]->short();
					if (short_str) write(short_str + ".\n");
	    		  }
            }
      	return 1;
      }
    if (sscanf(str, "at %s", item) == 1 || sscanf(str, "in %s", item) == 1) 
	  {
		int weight;
		string cap_item;

		item=lower_case(item);
		cap_item=capitalize(item);
		ob = present(item, this_player());
		if (!ob && environment(this_player())->id(item))
	    	ob = environment(this_player());
		if (!ob) ob = present(item, environment(this_player()));
		if (!ob) 
		  {
	    	write("There is no " + item + " here.\n");
	    	return 1;
		  }
		ob->long(item);
		if (!ob->can_put_and_get(item)) return 1;
		inv = all_inventory(ob);
		if (living(ob) && inv)
		  {
	    	for(i=0;i<sizeof(inv);i++) 
			 {
				string extra_str;

				if(!inv[i]) continue;
				extra_str = inv[i]->extra_look();
				if (extra_str) write(extra_str + ".\n");
	         }
		  }
	    if(!inv) return 1;
		if (living(ob))
		  write("\t" + cap_item + " is carrying:\n");
	     else write("\t" + cap_item + " contains:\n");
		  for(i=0;i<sizeof(inv);i++) 
			{
	 			string sh;

         		if(!inv[i] || !inv[i]->short()) continue;
				sh = inv[i]->short();
         		if (sh) write(sh + ".\n");
			}
      	return 1;
      }
    write("Look AT something, or what ?\n");
    return 1;
}

static rectify_path(path)
{
    return "closed/mcp"->rectify_path(path);
}

static list_files(path)
{
int path_stat;

    if(!path) path="*";
    path=rectify_path(path);
	if(!path) return 1;
    write(path+"\n");
    if(path!= "/") path = path + "/.";
	  else path+=".";
    ls(path);
    return 1;
}
 
tail_file(path)
{
   if(this_player()!=this_object()) return 0;
    if (!path) return 0;
	path=rectify_path(path);
	if(!path) return 1;
    if(file_size(path)==-2)
     {
       write("You cannot tail a directory.\n");
       return 1;
     }
    if (!tail(path)) return 0;
    return 1;
}
 
cat_file(path)
{
    if(this_player()!=this_object()) return 0;
    if (!path) return 0;
    path=rectify_path(path);
	if(!path) return 1;
    if(file_size(path)==-2)
     {
       write("You cannot cat a directory.\n");
       return 1;
     }
    cat(path);
    return 1;
}
 
tell(str)
{
    object ob;
    string who;
    string msg,it;
    if (!str || sscanf(str, "%s %s", who, msg) != 2) {
	write("Tell what ?\n");
	return 1;
    }
    it = lower_case(who);
    ob = find_living(it);
    if (!ob) {
	write("No player with that name.\n");
	return 1;
    }
    tell_object(ob, cap_name + " tells you: " + msg + "\n");
    if(talk) write("You tell "+who+": "+msg+"\n");
	else write("Ok.\n");
    return 1;
}
 
 
static edit(file)
{
    if (!file) 
	  {
		ed();
		return 1;
      }
    if(file!="-r") file = rectify_path(file);
	if(!file) return;
    if (!ed(file)) write("You do not have access to that file.\n");
    return 1;
}
 
drop_one_item(ob)
{
    int weight;
 
    if (ob->drop()) return 0;
    move_object(ob, environment(me));
    return 1;
}
 
drop_all(verbose,items)
{
    object inv;
    int i;

    if (!me || !living(me)) return;
    if(items && !present(items,me))
	  {
		 if(items[strlen(items)-1]=='s')
			{
			    items=extract(items,0,strlen(items)-2);
				if(!present(items,me))
				  {
				    write("You are not carrying that.\n");
					return 1;
				  }
			}
		 else
			{
				write("You are not carrying that.\n");
				return 1;
			}
		}
    inv = all_inventory(me);
    for(i=0;i<sizeof(inv);i++) {
	string out;
        if(!inv[i] || (items && !inv[i]->id(items))) continue;
	if (drop_one_item(inv[i]) && verbose) {
	    say(cap_name + " drops " + inv[i]->short()+".\n");
	    tell_object(me, "drop: " + inv[i]->short()+".\n");
	}
    }
}
 
converse()
{
    write("Give '/s' to stop.\n");
    write("]");
    input(this_object(),"converse_more");
    return 1;
}
 
static converse_more(str)
{
    string cmd;
    if (str == "/s") {
	write("Ok.\n");
	return;
    }
    if (str && str[0] == '!') {
	sscanf(str, "!%s", cmd);
	command(cmd);
    } else if (str != "") {
	say(cap_name + " says: " + str + "\n");
    }
    write("]");
    input(this_object(),"converse_more");
}
 
toggle_brief()
{
    brief = !brief;
    if (brief)
        write("Brief mode.\n");
    else
        write("Verbose mode.\n");
    return 1;
}
 
static trans(str)
{
    object ob;
    string out;
 
    if (!str)
	return 0;
    ob = find_living(str);
    if (!ob) {
	write("No such living thing.\n");
	return 1;
    }
    tell_object(ob, "You are magically transfered somewhere.\n");
	out = ob->query_name() + " arrives in a puff of smoke.\n";
    say(out);
    write(out);
    move_object(ob, environment(this_object()));
    return 1;
}
 
give_object(str)
{
    string item, dest;
    object item_ob, dest_ob;
    int weight;
    int coins;
 
    if (!str) return 0;
    if (sscanf(str, "%s to %s", item, dest) != 2) {
	write("Give what to whom ?\n");
	return 1;
    }
    dest = lower_case(dest);
	item = lower_case(item);
	item_ob = present(item, this_player());
	if (!item_ob) {
	    write("There are no " + item + " here.\n");
	    return 1;
	}
	if (environment(item_ob) == this_object() &&
	    call_other(item_ob, "drop", 0) == 1) {
	    return 1;
	} else 
	    if (!call_other(item_ob, "get")) {
		write("You can't get that !\n");
		return 1;
	    }
    dest_ob = present(dest, environment(this_player()));
    if (!dest_ob) {
	write("There is no " + capitalize(dest) + " here.\n");
	return 1;
    }
    move_object(item_ob, dest_ob);
    say(cap_name + " gives " + item + " to " + capitalize(dest) + ".\n");
    write("Ok.\n");
    return 1;
}
 
/*
 * Get all items here.
 */

get_all(from,container,items)
{
    object ob;
    int i,fail;
 
    if(items && !present(items,from))
	  {
		if(items[strlen(items)-1]=='s')
		   {
			  items=extract(items,0,strlen(items)-2);
			  if(!present(items,from))
			    {
				  if(items[strlen(items)-1]=='e')
				    {
					  items=extract(items,0,strlen(items)-2);
					  if(!present(items,from)) fail=1;
					}
				  else fail=1;
				}
		    }
		else fail=1;
	  if(fail)	
		 {
		   write("There is no such '"+items+"' to be found here.\n");
		   return 1;
		 }
	 }
    ob = all_inventory(from);
	if(!ob)
	  {
		write("There is nothing in the "+from->short()+" to get.\n");
	    return 1;
	  }
    for(i=0;i<sizeof(ob);i++) {
	if (ob[i]->short() && ob[i]->get()) {
	    string item;
	    int weight;
	    if(!ob[i] || (items && !ob[i]->id(items))) continue;
	    item=ob[i]->short();
		write(ob[i]->short() + ": Ok.\n");
		move_object(ob[i], this_object());
                if(item[0]=='a' || item[0]=='A') item=extract(item,2,strlen(item));
                if(!container)
		   say(cap_name + " takes a " + item + ".\n");
  		 else say(cap_name+" take a "+item+" from "+container+".\n");
                 if(container) from->add_weight(-weight);
	}
    }
}
 
static clone(str) 
{
    object ob;
    int syss;

    if (!str) {
	write("Clone what object ?\n");
	return 1;
    }
    str=rectify_path(str);
	if(!str) return 1;
    if(str && file_size(str+".c")<1) str=0; 
    if (!str) {
	write("Invalid file.\n");
	return 1;
    }
	str++;
    if(!find_object(str)) {sys(str);syss = 1;}
    ob = clone_object(str);
	move_object(ob,me);
    if(syss) sys(str, 1);
    say(cap_name + " fetches something from another dimension.\n");
    write("Ok.\n");
    return 1;
}
 
static destruct_local_object(str)
{
    object ob;
 
    if (!str)
	  {
		write("Destruct what ?\n");
		return 1;
      }
    str=lower_case(str);
    ob = present(str, this_player());
    if (!ob) ob = present(str, environment(this_player()));
    if (!ob) 
	  {
		write("No " + str + " here.\n");
		return 1;
      }
    if( ob->is_player())
     {
       write("You are not allowed to destruct players!\n");
       return 1;
     }
    if (ob->short())
        say(ob->short() + " is disintegrated by " + cap_name + ".\n");
    destruct(ob);
    write("Ok.\n");
    return 1;
}
 
static load(str)
{
    object env;
    if (!str) {
	write("Load what ?\n");
	return 1;
    }
    if(str[0]!='/') str=rectify_path(str);
	if(!str) return 1;
    if (!str) {
	write("Invalid file name.\n");
	return 1;
    }
    env = environment();
    /* We just call a non existing function in the object, and that way
     * force it to be loaded.
     */
    if(file_size(str+".c")<1)
     {
        write("No such file to load.\n");
        return 1;
     }
    sys(str);
    call_other(str, "???");
    sys(str, 1);
    write("Ok.\n");
    return 1;
}
 
static snoop_on(str)
{
    object ob;
    int ob_level;
 
    if (!str) {
	snoop();
	return 1;
    }
    ob = find_player(str);
    if (!ob) {
	write("No such player.\n");
	return 1;
    }
    snoop(ob);
    return 1;
}
 
static home(str) 
{
    if(!str || str == "") str = user_name;
	if(!file_size("/adm/"+str+"/workroom.c")) return;
    say(cap_name+" goes home.\n");
    move_object(this_object(),"adm/"+str+"/workroom");
    say(cap_name+" arives.\n");
    if(brief) glance();
    else look();
    return 1;
}

valid_read(str) { return "closed/mcp"->valid_read(str); }

valid_write(str) { return "closed/mcp"->valid_write(str); }

static wiz_score_list(arg) 
{
    if (arg) wizlist(arg);
    else wizlist();
    return 1; 
}

static show_realm_list()
{
	realm_list();
	return 1;
}
 
static remove_file(file) 
{
    if (!file) return 0;
    file=rectify_path(file);
	if(!file) return 1;
    rm(file);
	return 1;
}
 
static mv_file(str) 
{
string file, file2;

    if (!str || sscanf(str,"%s %s",file,file2)!=2) return 0;
	file=rectify_path(file);
	if(!file) return 1;
	file2=rectify_path(file2);
	if(!file2) return 1;
    mv(file,file2); return 1; 
}
 
static cp_file(str) 
{
string file, file2;

    if (!str || sscanf(str,"%s %s",file,file2)!=2) return 0;
    file=rectify_path(file);
	if(!file) return 1;
	file2=rectify_path(file2);
	if(!file2) return 1;
    cp(file,file2);
	return 1; 
}
 
static local_commands() { localcmd(); return 1; }
 
save_me(value_items)
{
   if(no_save) return;
    if(environment())
	 {
      saved_where=environment()->player_save_location();
	  if(!saved_where) saved_where=file_name(environment());
	 }
    if(!stringp(saved_where) || strchr(saved_where,'#'))
		 saved_where="adm/"+user_name;
    if(value_items!=2) save_inv();
    save_object("adm/"+user_name+"/"+user_name);
}
 
query_user_name() { return user_name; }

who(str)
{
    pointer list,list2;
    int i,size;
    string tmp;
    object env;

    if(str=="system")
      {
        "closed/mcp"->show_who(); 
        return 1;
      }

    list = users();

    for(size=sizeof(list);i<size;i++) 
       	if(list[i] && !strncmp(file_name(list[i]),"closed/sysop",12))
	    if(list2) list2+=({list[i]});
		else list2=({list[i]});

    write("There are "+sizeof(list2)+" Sysop(s) in session.\n\n");
    write("Who           Host/Ip                Where\n");
    write("--------------------------------------------------------------------\n");

	for(i=0,size=sizeof(list2);i<size;i++)
		 write(sprintf(tmp,"%-11s   %-20s   %-s\n",
	capitalize(list2[i]->query_user_name()),query_host_name(list2[i]),
	(env=environment(list2[i]))?file_name(env):""));
    return 1;
}
 
static cd(str) 
{
    str=rectify_path(str);
	if(!str) return 1;

    if(str=="/") current_path="";
	 else if(valid_read(str)) 
			{
			   int size;

			   size=file_size(str);
			   if(size==-1) write("No such file or directory.\n");
    	       else if(file_size(str)!=-2) write("No such directory.\n");
				 else 
			       {
					  current_path=str;
					  ++current_path;
				   }
			 }
    write("/" + current_path + "\n");
    return 1;
}
 
static grep_file(str)
{
  grep(str);
  write("grep output will be appended to the file /log/"+user_name+".grep\n");
  write("\n	* please allow a few moments for the program to finnish running.\n");
  return 1;
}

static read_log(str)
{
string file;
 
   if(!stringp(str)) return more("/log/"+user_name);
   if(str[0]=='.') str=user_name+str;
   file=valid_read("/log/"+str);
   if(!file)
     {
        write("No such file.\n");
        return 1;
     }
   return more("/"+file);
} 
 
static purge_log(str)
{
   if(stringp(str))
	 {
		if(str[0]=='.') str=user_name+str;
	    return remove_file("/log/"+str);
	 }
    else return remove_file("/log/"+user_name);
}
 
 
more(path) {
   if(this_player()!=this_object()) return 0;
    if (!path) return 0;
	path=rectify_path(path);
	if(!path) return 1;
    if(file_size(path)==-2)
     {
       write("You cannot more a directory.\n");
       if(log_flag)
        {
          log_flag=0;
          finnish2();
        }
       return 1;
     }
    more_file = path;
    more_line = 1;
    if(cat(more_file, more_line, chunk)==0) {
	write("No such file\n");
        if(log_flag)
	 {
           log_flag=0;
	   finnish2();
         }
	return 1;
    }
    input(this_object(),"even_more");
    write("More: line " + (chunk+1) + " (q/u/r/<return>) ");
    return 1;
}
 
static even_more(str) 
{
    if (str == "q") 
      {
	write("Ok.\n");
	if(log_flag)
	 {
	   log_flag=0;
	   finnish2();
	 }
	return;
       }
     else if (str == "u") 
            {
	      more_line -= chunk;
	      if (more_line < 1) more_line = 1;
            }
          else if(str=="r") {}
    else more_line+=chunk;
    if(cat(more_file, more_line, chunk)==0) {
	more_file = 0;
        if(log_flag)
         {
            log_flag=0;
            finnish2();
         }
        else write("EOF\n");
	return;
    }
    write("More: line " + (more_line + chunk) + " (q/u/r/<return>)");
    input(this_object(),"even_more");
}
 
static pwd() 
{
    write("/" + current_path + "\n");
    return 1;
}
 
static makedir(file) 
{
    if (!file) return 0;
    file=rectify_path(file);
	if(!file) return 1;
    if (mkdir(file))
	write("Ok.\n");
    else
	write("Fail.\n");
    return 1;
}
 
static removedir(file) 
{
    if (!file) return 0;
	file=rectify_path(file);
	if(!file) return 1;
    if (rmdir(file))
	write("Ok.\n");
    else
	write("Fail.\n");
    return 1;
}
 
query_path() { return current_path; }
 
 
add_standard_commands() {
    add_action("church_clock","clock");
    add_action("toggle_talk", "talk");
    add_action("give_object","give");
    add_action("save_character","save");
    add_action("quit","quit",2);
    add_action("communicate","say");
    add_action("communicate",({"'",";"}), 1);
    add_action("put","put");
    add_action("pick_up",({"get","take"}));
    add_action("drop_thing","drop");
    add_action("inventory",({"inventory","i"}));
    add_action("look","look");
    add_action("glance","glance");
    add_action("examine","examine");
    add_action("examine", "exa", 2);
    add_action("ext_help",({"help","help2"}));
    add_action("tell","tell");
    add_action("converse","converse",2);
    add_action("toggle_brief","brief",2);
    add_action("who",({"who","people"}));
    add_action("clock",({"date","time"}));
    add_action("short_mv",({"e","w","n","s","u","d","sw","se","ne","nw"}),2);
}
 
short_mv()
{
  if(query_verb()=="sw") command("southwest");
   else if(query_verb()=="se") command("southeast");
    else if(query_verb()=="nw") command("northwest");
      else if(query_verb()=="ne") command("northeast");
	else if(query_verb()=="w") command("west");
	  else if(query_verb()=="e") command("east");
	    else if(query_verb()=="n") command("north");
	      else if(query_verb()=="s") command("south");
		else if(query_verb()=="u") command("up");
		  else if(query_verb()=="d") command("down");
 return 1;
}

static update_object(str) {
   object ob;
   string temp;
   object inv;
   int no_inv;
   string r_void;
 
    if(file_size("/adm/"+user_name+"/void.c")<1) r_void="room/void";
      else r_void="/adm/"+user_name+"/void";
    if (!str) str="/"+file_name(environment(this_player()));
    if(str[0]!='/') str=rectify_path(str);
	if(!str) return 1;
    if (!str) return 1;
    ob = find_object(str);
    if(!ob) {
        write("No such object "+str+".\n");
        return 1;
      }
    inv=first_inventory(ob);
    if(!inv) no_inv=1;
        else while(inv) {
	      if(!inv->query_npc()) move_object(inv,r_void);
	       else destruct(inv);
              inv=first_inventory(ob);
            }
    destruct(ob);
    write(str + " destructed.\n");
    sys(str);
    write("Now attempting to load "+str+"\n");
    call_other(str,"???");
    ob=find_object(str);
    write("Loading of "+str+" was successful.\n");
    sys(str, 1);
    if(!no_inv) {
       inv=first_inventory(r_void);
        while(inv) {
          string item_name;
      
          item_name=inv->query_id(0);
          if(!item_name) item_name=inv->query_user_name();
          if(!item_name || present(item_name,ob)) destruct(inv);
            else move_object(inv,ob);
          inv=first_inventory(r_void);
        }
      write("Restroration of "+str+" contents complete.\n");
      call_other(r_void,"reset",1);
    }
  return 1;
}
 
static reset_object(str)
{
object ob;
string temp;
  if(str)
   {
     ob=present(str);
     if(!ob) ob=present(str,environment());
     if(!ob) find_living(str);
   }
  if(!ob)
   {
     if(!str) str="/"+file_name(environment(this_player()));
     if(str[0]!='/')
     str=rectify_path(str);
	 if(!str) return 1;
     ob=find_object(str);
     if(!ob)
      {
        write("No such object found.\n");
        return 1;
      }
    }
  ob->reset(1);
  write(file_name(ob)+" has been reset.\n");
  return 1;
}
 
static set_room_names(str)
{
 
  if(str=="off")
   {
     write("You no longer see the room names.\n");
     no_room_names=1;
     return 1;
   }
  write("You see room names.\n");
  no_room_names=0;
  return 1;
}
 
ext_help(str) 
{
	int lev;
    if(!str) 
	 {
		if(query_verb()=="help2") cat("/doc/help2");
			else cat("/doc/help");
		return 1;
     }
    if (str) return cat("/doc/" + str);
}
 
clock()
{
int hour;
string am_pm;
int min,sec;
string time_str,time2;
 
  time_str=allocate(5);
  sscanf(ctime(time()),"%s %s %s %s %s",time_str[0],time_str[1],time_str[2],time_str[3],time_str[4]);
  time2=explode(time_str[3],':');
  if(sizeof(time2)<3)
   {
     sscanf(ctime(time()),"%s %s  %s %s %s",time_str[0],time_str[1],time_str[2],time_str[3],time_str[4]);
     time2=explode(time_str[3],':');
   }
  sscanf(time2[0],"%d",hour);
  if(hour>12) 
   {
     hour-=12;
     am_pm="pm";
   }
   else am_pm="am";
   if(hour==0) hour=12;
  if(query_verb()=="time")
     write("The time is: "+hour+":"+time2[1]+":"+time2[2]+am_pm+".\n");
  if(query_verb()=="date")
     write("The Date is: "+time_str[0]+"  "+time_str[1]+" "+time_str[2]+", "+time_str[4]+"\n");
   return 1;
}
 
church_clock(str) 
{
    if(str == "off") call_other("closed/clock", "show_off");
    else call_other("closed/clock", "clock");
   return 1;
}
 
toggle_talk(str) 
{
	if(str) return;
	if(talk) {talk = 0;write("No talk echo.\n");return 1;}
	talk = 1;write("Talk echo.\n");return 1;
}
 
sys(str, flag) 
{
    if(!str || file_size("/"+str+".c") < 15000) return;
    if(!flag) shout("System delay, please hold....");
    else shout("done.\n");
}

chunk_set(num) {
	num = numb(num);
	if(num > 40 || num < 1) return;
	chunk = num;
	write("CHUNK set to "+num+".\n");
	return 1;
}

numb(num) {if(sscanf(num, "%d", num)) return num;}

static wiz_tell(str) 
{
	object ob;
	int i;

  ob = users();
  if(!str) 
	{
		write("Wiztell what?\n");
		return 1;
	 }
   for(i=0;i<sizeof(ob);i++) 
	{
	  if(!ob[i]) continue;
      if(ob[i]==this_object()) continue;
      tell_object(ob[i], capitalize(this_player()->query_real_name()) +
				  " <wiz channel> : "+str+"\n");
	}
  write("Sent.\n");
  return 1; 
}

move_player(dir_dest, optional_dest_ob)
{
    string dir, dest;
    int is_light, i;

    if (!optional_dest_ob) 
     {
	if (!dir_dest || sscanf(dir_dest, "%s#%s", dir, dest) != 2)
          {
	    tell_object(this_object(), "Move to bad dir/dest\n");
	    return;
	  }
     }
    else
     {
	dir = dir_dest;
	dest = optional_dest_ob;
     }
    say(cap_name + "leaves.\n");
    move_object(this_object(), dest);
	if (!optional_dest_ob && !no_room_names &&
		file_name(environment())==dest)
	    tell_object(this_object(), "/" + dest + "\n");
	 else if(optional_dest_ob && !no_room_names &&
		environment()==dest)
		  tell_object(this_object(), "/"+file_name(dest)+"\n");
    say(cap_name+" arrives.\n");
     if(optional_dest_ob && environment()==dest ||
        !optional_dest_ob && file_name(environment())==dest)
       if (brief) glance();
         else look();
}

static shut_down(num)
{
  log_file("SHUTDOWN",capitalize(user_name)+" Shutdown the system with "+num+" delay @"+ctime(time())+".\n");
  if(!num) shutdown();
   else 
	{
	   int d;

	   sscanf(num,"%d",d);
	   if(numberp(d)==1) "closed/shut"->shut(d);
		 else write("Invalid argument to shutdown()\n");
	}
  return 1;
}

save_inv()
{ 
	if(!no_save && !save_inventory(this_object(),"adm/"+user_name+"/save_inv.s"))
		write("Error: Inventory not saved!\n");
    if(no_save || !query_ip_number(this_object()))
	  {
		int i;
	    object arr;

		for(i=0,arr=all_inventory(this_object());i<sizeof(arr);i++)
			 if(arr[i])
			   {
				 int c;
				 object arr2;

				 if(first_inventory(arr[i]))
				   for(c=0,arr2=all_inventory(arr[i]);c<sizeof(arr2);c++)
					  if(arr2[c]) destruct(arr2[c]);
				  destruct(arr[i]);
			   }
			     
	  }
}

restore_inv() 
{
  if(user_name=="guest") return;
  write("Restoring inventory, Please wait...\n");
  if(restore_inventory(this_object(),"adm/"+user_name+"/save_inv.s"))
    write("Done.\n\n");
}
	
is_player() { return 1;}

query_talk() {return talk;}
illegal_patch() {}
