#include "object.h"

#define DIR_WORDS_SHORT ({"l","r","u","d","i","o","e","w","s","n","nw",\
			  "ne","sw","se"})

#define DIR_WORDS ({"left","right","up","down","in","out","east","west",\
		    "south","north","northwest","northeast",\
		    "southwest","southeast"})

#define NUM_WORDS ({"no", "one", "two", "three", "four", "five", "six",\
		    "seven", "eight", "nine", "ten"})

  /* Expand later to corisponds with exit types, (ie. A door, stairs.. ) */

#define EXIT_PREFIX1 ({"a door","stairs","a path","a portal","a bridge",\
		       "a hole","a road"})

global;

static string MCP,DAY_NIGHT,REALM;
static pointer dest_dir;
static string walls;
static string other_look, full_long_desc,extra_long;
static pointer items, property;
static string nope, blockf, blocks, blockv;
static int day_night, set_start, base_light;

init(ob)
{
    int s,i;

    if (pointerp(dest_dir)) 
      {
       for(s=sizeof(dest_dir);i<s;i++)
            add_action("move", dest_dir[i][0]);
      }

   if (query_property("DN")) query_time_change();
   if (query_property("UW")) ob->set_holding_breath(1);

   add_action("open_close_door",({"open","close"}),2);
   add_action("lock_unlock_door",({"lock","unlock"}),2);

   ex_ent();
}

static convert_number(n) 
{
string i;

    if (n > 10) return "a lot of";

    return NUM_WORDS[n];
}

static ex_ent() 
{
int count, ran, s;
string dir;
object msg_room;

   if(!pointerp(dest_dir)) return;

   for(s=sizeof(dest_dir);count<s;count++)
     {
       if((msg_room=verify(dest_dir[count][1])))
         {
           dir=reverse(dest_dir[count][0]);

           if(dir) ran=random(100);
             else ran=70;

           if(ran>85) tell_room(msg_room,"You hear something "+dir+".\n");

           if(ran>=70 && ran<=85) tell_room(msg_room,"You hear something.\n");
        }
    }
}

set_extra_long(str) { extra_long=str; }

query_extra_long() { return extra_long; }

long(str) 
{
    int i,s,r,sl;
    string exit_str, prefix_str;

    if (!str)
      {

            if (!pointerp(dest_dir)) full_long_desc=" No obvious exits.\n";
              else
               {
		 exit_str=full_long_desc="";

                 for(r=s=sizeof(dest_dir);i < s;i++) 
	           {
		     if(dest_dir[i][2])
		       {
			 if(pointerp(dest_dir[i][2]))
			   {
			     if(dest_dir[i][2][0]) {r--;continue;}
			   }
			 else 
			   {  
			     if(!stringp(dest_dir[i][2])) {r--;continue;}

                             if(call_other(this_object(),dest_dir[i][2],this_player()))
			      { r--; continue; }
			    }
		       }

		    prefix_str=get_exit_prefix(dest_dir[i][0],dest_dir[i][2]);

		    sl=strlen(exit_str);

		    sl += (full_long_desc=="")?35:0;

	            if(sl+strlen(prefix_str)>74)
		      {
		        full_long_desc+=exit_str+"\n";
		        exit_str="    ";
	              }

                    exit_str+=prefix_str;

                    if (i+2 == s) exit_str+=" and ";
                      else if(i+1 == s) 
		             { 
			        if(exit_str!="    ")
					 full_long_desc+=exit_str+"\n"; 
			     }
  			  else exit_str+=", ";
                  }

            if(!r) exit_str=" No obvious exits.\n";
             else if (r == 1) exit_str="    There is one obvious exit: ";
                  else exit_str="    There are " + convert_number(r) +
                      		" obvious exits: ";

           if(strlen(exit_str)>4) full_long_desc=exit_str+full_long_desc;
         }

        return long_desc+full_long_desc+(extra_long?extra_long:"");
      }

    if(str=="sky")
	return DAY_NIGHT->sky_msg();

    if(strchr(str,' '))
           sscanf(str,"%s %d",str,r);
	else r=1;

    if(r>1)
      {
         pointer inv;

         inv=all_inventory(this_object());

         for(s=sizeof(inv),i=0;i<s;i++)
	   if(inv[i]->id(str)) r--;
       }

    if(str=="door")
      {
        for(i=0,s=sizeof(dest_dir);i<s;i++)
           {
             if(!pointerp(dest_dir[i][2])) continue;

             if(!(--r))
	       { 
		  string tmp;

		  if(dest_dir[i][2][5]?
		     !call_other(dest_dir[i][1],"query_door_open",dest_dir[i][2][5]):
		     !dest_dir[i][2][1])
			   tmp="\nIt is closed.\n";
			       else tmp="\nIt is open.\n";

                  if(dest_dir[i][2][4]) return dest_dir[i][2][4]+tmp;
			else return "You see nothing special."+tmp;
		}
           }
      }

    if(items)
      for(i=0,s=sizeof(items);i<s;i++)
       {
           if (search_array(items[i][0],str)==-1) continue;

	   if(!(--r))
               if(items[i][1]) return items[i][1]+"\n";
	          else return "You see nothing special.\n";
       }
}

get_exit_prefix(exit_verb,exit_type)
{
   string combine;


   if(!exit_type || strstr("updownexitleaveoutenter",exit_verb))
     {
         /* expand later to usethings like stairs and what not */

         switch(type(exit_type))
           {
	      case 2:
		  if(strstr("exitleaveenter",exit_verb))
				return "a door "+exit_verb+" by";

		 return "a door leading "+exit_verb;

              default: return exit_verb;
	   }
     }
   if(pointerp(exit_type)) exit_type=exit_type[0]+1;
	
   return EXIT_PREFIX1[exit_type-1]+" to the "+exit_verb;
}

move(str) 
{
    int i,s;
    string verb;

    verb=query_verb();

    for(s=sizeof(dest_dir);i<s;i++)
      {
        if (verb == dest_dir[i][0]) 
          {
             if (!verify(dest_dir[i][1])) 
               {
                  if (nope) write(nope);
                      else write("That exit is closed.\n");

        	  return 1;
               }

	    if(!this_player()->query_ghost() && (query_wall(dest_dir[i][1]) ||
		 dest_dir[i][1]->query_wall(file_name(this_object()))))
                {
		  tell_object(this_player(), "A magical force stops you.\n");
		  return 1;
	        }

	    if(!exit_action(dest_dir[i])) return 1;

            MCP->move_player( this_player()  , dest_dir[i][0],
			      dest_dir[i][1] , dest_dir[i][4] );
            return 1;
          }
    }
}

exit_action(dest)
{
   switch(type(dest[2]))
     {
	case 1:
		return call_other(this_object(),dest[2],this_player());
	case 2:
		if(this_player()->query_ghost()) return 1;
		if(dest[2][5]?
		   !call_other(dest[1],"query_door_open",dest[2][5]):
		   !dest[2][1])
		 {
		    write("You must first open the door.\n");
		    return;
		 }
		return 1;
	case 4:
		return 1;
	case 18:
		return 1;
	default:
		write("Error: bad type '"+type(dest[2])+"' in dest_dir.\n");
		return 0;
      }
}

open_close_door(str)
{
  int door,i,s;
  string verb;

  verb=query_verb();

  if(str!="door" && sscanf(str,"door %d",door)!=1) return 0;

  if(!door) door=1;

  for(s=sizeof(dest_dir);i<s;i++)
    {
       if(pointerp(dest_dir[i][2]) && !(--door))
	 {
	    if(verb=="open")
	      {
	        if(dest_dir[i][2][5]?
		   call_other(dest_dir[i][1],"query_door_open",dest_dir[i][2][5]):
		   dest_dir[i][2][1])
		 {
		    write("The door is already open.\n");
		    return 1;
		 }
	
	        if(dest_dir[i][2][5]?
		   call_other(dest_dir[i][1],"query_door_locked",dest_dir[i][2][5]):
		   dest_dir[i][2][2])
		  {
		    write("You must unlock the door first.\n");
		    return 1;
		  }

		if(dest_dir[i][2][5]) 
		   call_other(dest_dir[i][1],"remote_open_close",dest_dir[i][2][5]);
		     else dest_dir[i][2][1]=1; 

                write("You open the door.\n");
		say(this_player()->query_name()+" opens a door.\n");
		return 1;
               }
	    if(dest_dir[i][2][5]?
               !call_other(dest_dir[i][1],"query_door_open",dest_dir[i][2][5]):
	       !dest_dir[i][2][1])
	      {
		 write("The door is already closed.\n");
	         return 1;
	      }

	    if(dest_dir[i][2][5])
		call_other(dest_dir[i][1],"remote_open_close",dest_dir[i][2][5]);
                  else dest_dir[i][2][1]=0;

	    write("You close the door.\n");
	    say(this_player()->query_name()+" closes a door.\n");
	    return 1;
         }
      }
}

find_door(str)
{
  int i,s;

  for(s=sizeof(dest_dir);i<s;i++)
     if(dest_dir[i][0]==str) return i;
}

query_door_locked(dir)
{
  return dest_dir[find_door(dir)][2][2];
}

query_door_open(dir)
{
  return dest_dir[find_door(dir)][2][1];
}

remote_lock_unlock(dir)
{
  int i;

  i=find_door(dir);

  dest_dir[i][2][2]=!dest_dir[i][2][2];
}

remote_open_close(dir)
{
  int i;

  i=find_door(dir);
   
  dest_dir[i][2][1]=!dest_dir[i][2][1];
}

lock_unlock_door(str)
{
  int door,i,s;
  string verb;

  verb=query_verb();

  if(strncmp(str,"door",4)) return 0;

  if(!door) door=1;

  for(s=sizeof(dest_dir);i<s;i++)
    {
     if(pointerp(dest_dir[i][2]) && !(--door))
       {
          if(dest_dir[i][2][5]? 
	     call_other(dest_dir[i][1],"query_door_open",dest_dir[i][2][5]):
	     dest_dir[i][2][1])
              {
                 write("You cannot do that while the door is open.\n");
                 return 1;
              }
	    if(dest_dir[i][2][3] && !present(dest_dir[i][2][3],this_player()))
		{
		   write("You do not have the key to this door.\n");
		   return 1;
		}

	    if(verb=="lock")
	      {
	        if(dest_dir[i][2][5]?
                   call_other(dest_dir[i][1],"query_door_locked",dest_dir[i][2][5]):
	           dest_dir[i][2][2])
		 {
		    write("The door is already locked.\n");
		    return 1;
		 }
	
	        if(dest_dir[i][2][5])
			call_other(dest_dir[i][1],"remote_lock_unlock",dest_dir[i][2][5]);
		  else dest_dir[i][2][2]=1; 
                write("You lock the door.\n");
		say(this_player()->query_name()+" locks a door.\n");
		return 1;
               }
	    if(dest_dir[i][2][5]?
               !call_other(dest_dir[i][1],"query_door_locked",dest_dir[i][2][5]):
	       !dest_dir[i][2][2])
	      {
		 write("The door is already unlocked.\n");
	         return 1;
	      }

	    if(dest_dir[i][2][5])
		call_other(dest_dir[i][1],"remote_lock_unlock",dest_dir[i][2][5]);
	          else dest_dir[i][2][2]=0;

	    write("You unlock the door.\n");
	    say(this_player()->query_name()+" unlocks a door.\n");
	    return 1;
         }
      }
}

reverse(str)
{
  string to_the;

  to_the="to the ";

  switch(str)
   {
	case "west": 
		return to_the+"east";
	case "east":
		return to_the+"west";
	case "north":
		return to_the+"south";
	case "south":
		return to_the+"north";
	case "northwest":
		return to_the+"southeast";
	case "northeast":
		return to_the+"southwest";
	case "southwest":
		return to_the+"northeast";
	case "southeast":
		return to_the+"northwest";
	case "up":
		return "from below";
	case "down":
		return "from above";
	case "left":
		return "to your right";
	case "right":
		return "to your left";
	default:
		return 0;
	}
}

query_day_night() {return day_night;}

query_time_change(new_time,light_level) 
{
    int tmp;

    if(!query_property("DN")) return;

    if(!new_time) 
      {
         tmp = call_other(DAY_NIGHT, "query_time");

	 new_time=tmp[0];
	 light_level=tmp[1];
      }

    if(day_night) 
      {
         if(day_night<5) tmp=2;
           else if(day_night==5) tmp=4;
		else if(day_night==6) tmp=6;
		  else if(day_night==7) tmp=8;
		    else tmp=10;

         tmp=light_level-(day_night-tmp);
       }
    else tmp=light_level;

    day_night=new_time;

    set_light(tmp);

    this_object()->close_shop(day_night);
}

query_dest_dir()	{return dest_dir;	}

set_room_light(n)
{
   base_light=n;
   set_light(n);
}

query_room_light()
{
   query_time_change(); 
   return set_light(0);	
}

query_long()		{return long_desc;	}
query_full_long()	{return full_long_desc;	}

query_property(str) 
{
    int i,s;

    if (!str) return property;

    if (!property) return 0;

    if (stringp(property)) return str == property;

    for(s=sizeof(property);i<s;i++)
        if (property[i] == str) return 1;

    return 0;
}

set_dest_dir(arr) 
{
   int i,s;

   if (pointerp(arr)) 
     {
          dest_dir = arr;

	  for(s=sizeof(dest_dir);i<s;i++)
	    {
		if(!pointerp(ids)) ids=({dest_dir[i][0]});
	           else ids+=({dest_dir[i][0]});

		if(pointerp(dest_dir[i][2])) ids+=({"door"});
	    }
          return 1;
     }
   return;
}

set_items(arr) 
{
   int i,s;

   if (pointerp(arr)) 
     {
        items = arr;
	for(s=sizeof(arr);i<s;i++)
	   {
		if(pointerp(ids)) ids+=arr[i][0];
			else ids=arr[i][0];
	   }
        return 1;
     }
}

query_other_look(str)     
{
    string null;
    int s,cn;

    if (!str) return other_look;

    for(s=sizeof(other_look);cn<s;cn++)
        if(str == other_look[cn][0]) return other_look[cn][1];

   return;
}

set_other_look(arr) 
{
 int i,s;

    if (pointerp(arr)) 
      {
           other_look = arr;

	   for(s=sizeof(other_look);i<s;i++)
	     {
		 if(pointerp(ids)) ids+=({other_look[i][0]});
			else ids=({other_look[i][0]});
	     }

           return 1;
      }
}

set_property(arr) 
{
 int el;

   if(stringp(arr)) arr=explode(arr,':');

   if (pointerp(ids) && pointerp(arr)) 
     {
         property = arr;

         if(search_array(property,"DN")==-1 && (el=search_array(ids,"sky"))!=-1)
	     ids=del_element(ids,el);
		
         return 1;
     }
}

some_say(str) 
{
    int s,count, ran;
    string dir,dirc;
    object msg_room;

    if(!dest_dir) return;

    for(s=sizeof(dest_dir);count<s;count++)
     {
        dirc = dest_dir[count][1];
        msg_room=verify(dirc);

        if(msg_room)
         {
           ran=random(100);

           if (!str) str = "something";

           dir=reverse(dest_dir[count][0]);

           if(!dir && ran>86 && ran<96) ran=86;

           if(!dir && ran>98) ran=98;

           if(ran>98) tell_room(msg_room,"You hear "+dir+" "+str+"\n");

           if(ran>95 && ran<99) tell_room(msg_room,"You hear "+str+"\n");

           if(ran>86 && ran<96) tell_room(msg_room,"You hear voices "+dir+".\n");
           if(ran>65 && ran<87) tell_room(msg_room,"You hear voices.\n");
         }
    }
}

verify(path)
{
object ob;

    if(path[0]=='/') path=extract(path,1);

    if(strncmp(path,REALM,strlen(REALM))) path=REALM+"/"+path;

    if((ob=find_object(path))) return ob;

    if(file_size("/"+path+".c") > 0) 
      {
        call_other(path,"???"); 
        return find_object(path);
      }

    return 0;
}

query_wall(str) 
{
	int count,s;

        if(!dest_dir) return;

        if(!walls) return;

	if(!str) return walls;

	if(strchr(str,'/')) 
	 {
    	   if(!query_dest_dir(str)) return;

	   for(s=sizeof(walls);count < s;count++)
        	if(query_dest_dir(str) == walls[count]) return 1;

 	   return;
	}

	if(!query_dir(str)) return;

	for(count = 0;count < s;count++) 
		if(lower_case(str) == walls[count]) return -1;

	return 1;
}

 /* str = exit verb (ie east,west..) or exit room names ( ie obj/room )

    flag  0 or 1, 0 returns exit verbs (ie east,west..)
                  1 returns exit room names (ie obj/room )

    flag2 0 or 1, 0 str is searching by exit verb ( ie east,west..)
                  1 str is searching by exit room names ( ie obj/room )
 */

query_dir(str,flag,flag2) 
{

	int s,count;

        if(!dest_dir) return;

        s= sizeof(dest_dir);

	if(flag) flag=1;

        if(flag2) flag2=1;

	if(!str) 
          {
		pointer all_dir;

		for(;count<s;count++)
                   {
			if(all_dir) all_dir=({dest_dir[count][flag]});
			    else all_dir +=({dest_dir[count][flag]});
		   }

                return all_dir;
	}

      for(count=0;count<s;count++) 
         if(str == dest_dir[count][flag2]) return dest_dir[count][flag];

      return;
}

set_wall(str, tim) 
{
	string tmps;

	if(!str) return;

	str=lower_case(str);

	if(!numberp(tim)) tim = 30.0;
	    else tim=0.0+tim;

	if(walls) tmps = implode(walls, ':');
	    else tmps = 0;

	if(str != "all") 
          {
		if(walls)  walls += ({str});
		    else tmps = ({str});

		call_out("remove_wall", tim, str);

		return 1;
          }

	walls = query_dir();

	call_out("remove_wall", tim, "all");

	return 1;
}

remove_wall(str)
{
	string tmp;
	int el;

        if(!walls || !stringp(str)) return;

        str=lower_case(str);

	if(str != "all") 
          {

		el=search_array(walls,str);

		if(el) walls=del_element(walls,el);
		return;
	  }

	walls = 0;
}

reset(arg)
{
  REALM=query_realm(this_object(),2);
  MCP=(strlen(REALM)>1?(REALM+"/"):"")+"closed/mcp";
  DAY_NIGHT=(strlen(REALM)>1?(REALM+"/"):"")+"obj/obj_dev/day_night";
  property=({"DN"});
  ids=({"sky"});
  set_can_get_out(1);
  set_can_put_in(1);
  return 1;
}
